
$(function(){
	messageList.init();
	// 初始化tab
	Mine.initTab();
	var titleHtml="<span id=\"btn-backLink\" onclick=\"window.history.back();\" class=\"titleLeft\" style=\"float: left; padding-left: 12px; padding-right: 20px; padding-top: 6px; font-size: .8em; cursor: pointer;\">\n" +
        "<img src=\"assets/X.png\" height=\"24\" width=\"24\">\n" +
        "</span>\n" +
        "<span id=\"btn-iframe-title\" class=\"titleCenter\">消息中心</span>";
	if(M_isIos){
		titleHtml="<span id=\"btn-backLink\" onclick=\"window.history.back();\" class=\"titleLeft\" style=\"float: left; padding-left: 10px; padding-right: 10px; padding-top: 14px; font-size: .8em; cursor: pointer;\">\n" +
            "<img src=\"assets/X.png\" height=\"16\" width=\"16\">\n" +
            "</span>\n" +
            "<span id=\"btn-iframe-title\" class=\"titleCenter\" style=\"padding-top: 14px;font-size: 0.8em;\">消息中心</span>";
        $(".mainTitleDiv").css("height","64px");
	}
	$(".mainTitleDiv").html(titleHtml);
});

var ls = window.localStorage;
var myScroll;
var pullDown = document.getElementById('pullDown');
var pullUp = document.getElementById('pullUp');
var messageList = {
	showMask : function(theme, msg) {
		$.mobile.showPageLoadingMsg(theme, msg);
		$(".maskDiv").css("display", "block");
	},
	hideMask : function(theme, msg) {
		$.mobile.hidePageLoadingMsg(theme, msg);
		$(".maskDiv").css("display", "none");
	},
	init : function() {
		var isLogined = ls.getItem('isLogined');
//		if(isLogined == "0" || isLogined == null) {
//			window.location.href = "./login.html";
//		}
		ls.removeItem('_isMsg');
		this.getAllUrl = '/rest/sendMessage/getAllByPage';
		this.userId = ls.getItem('_userId');
		this.page = 1; // 第几页
		this.rows = 10; // 单页显示几个
		this.template = _.template($('#msg-item').html());
		this.$container = $('#message-list');
		this.getData();
		this.bindEvents();
	},
	getData: function () {
		var that = this;
		var url = that.getAllUrl;
		var data = {userid: that.userId,page:this.page,rows:this.rows};
		var callback = function () {
			that.renderList();
		}
		that.ajaxCall(url,data,callback);
	},
	ajaxCall: function (url,data,cb) {
		var that = this;
		$.ajax({
			url: module_exports.entry.index + url,
			type: 'POST',
			data: data,
			dataType: 'json',
			beforeSend: function () {
				$('#ajax-loading').show();
			},
			success: function(res){
				if(!res.success){
					$('#btn-loading').hide();
					$('#btn-loading-error').html('获取数据失败: ' + res.errorReason).show();
					return 0;
				}
				$('#ajax-loading').hide();
				that.totalCount = res.returnValue.total;
				that.maxPage = Math.ceil(that.totalCount / that.rows);
				that.msgList = res.returnValue.list;
				cb(res);
				if(myScroll){
					myScroll.refresh();
				}else{
					myScroll = new IScroll('#msg-wrapper', { click: true, tap: true, mouseWheel: false});
					that.bindRefreshEvents(myScroll);
				}
			},
			error: function(e){
				$('#btn-loading').hide();
				$('#btn-loading-error').html('网络异常, 点击重新加载 ').show().click(function () {
					window.location.reload();
				});
			}
		});
	},
	renderList: function (append) {
		var template = this.template;
		var list = this.$container;
		append || list.empty();
		_.each(this.msgList, function (msg) {
			//for(var i =0;i<10;i++){
			//	msg.title+=i;
				dealHttpUrl(msg);
				dealImgUrl(msg);
				list.append(template(msg));
			//}
		})
		function dealImgUrl(msg){
			var imgSuffix = msg.imgurl.match(/(images\/.*)$/);
			if(imgSuffix != null){
				imgSuffix = imgSuffix[1];
				var imgPrefix = module_exports.entry.imgPrefix;
				msg.imgurl = [imgPrefix,imgSuffix].join('/')
			}
			return msg;
		}
		function dealHttpUrl(msg){
			if(msg.htmlurl){
				var isHttp = msg.htmlurl.match(/^http/);
				if(isHttp == null){
					msg.htmlurl = 'http://'+msg.htmlurl;
				}
			}

			return msg;
		}
	},
	bindEvents: function () {
		$("#backLink").bind("click",function() {
			window.location.href = "../admin/evectionEntry.html";
		});
		var locker = false;
		$('#message-list').on('click', '.message-item', function () {
			if(locker) return;
			locker = true;
			var $dom = $(this);
			$.ajax({
				url: module_exports.entry.index + '/rest/sendMessage/updateSendMessage',
				type: 'POST',
				data: {id: $dom.data('id')},
				dataType: 'json',
				success: function(data){
					$dom.find('.msg-icon').removeClass('pristine');
					var url = $dom.data('url');
					if(url){
						var currentTime = new Date().getTime();
						currentTime = window.btoa(currentTime);
						if(~url.indexOf('?')){
							url = url + '&isLogined=' + currentTime;
						}else{
							url = url + '?isLogined=' + currentTime;
						}

						// 添加 oaId 和 userId
						_.each(['_oaId','_userId','_role','_userName'],setUrl);
						Common.redirectURL(url, $('.msg-title').data('title'),'webview');
						function setUrl(name){
							url = url + '&'+name+'='+encodeURIComponent(ls.getItem(name))
						}
					}
				},
				error: function(e){
					$('#btn-loading').hide();
					$('#btn-loading-error').html('网络异常, 点击重新加载 ').show().click(function () {
						window.location.reload();
					});
					$('#ajax-loading').show();
				},
				complete: function () {
					locker = false;
				}
			});

		})
	},
	bindRefreshEvents: function (s) {
		var that = this;
		if(s){
			s.hasVerticalScroll || (pullUp.style.display = 'none');
			s.on('scrollEnd', function () {
				console.log('scrollEnd: ')
				console.log(this)
				if(this.hasVerticalScroll){ // 可以滚动
					if(!this.y ){
						console.log('下拉刷新');
						that.refreshList();
					}else{
						var scrollY = Math.abs(this.y)+5;
						if(scrollY > Math.abs(this.maxScrollY)){
							console.log('上拉加载更多')
							that.loadMore();
						}
					}
				}else{

				}

			})
			s.on('refresh', function () {
				console.log('refresh: ')
				pullUp.querySelector('.pullUpLabel').innerHTML = '上拉加载更多...';
				if(that.totalCount >= that.$container.children().length){
					pullUp.style.display = 'none';
				}else{
					pullUp.style.display = 'block';
				}
			})
		}
	},
	refreshList: function () {
		var that = this;
		var url = that.getAllUrl;
		var data = {userid: that.userId,page:1,rows:this.rows};
		var callback = function () {
			that.page = 1;
			that.renderList();
		}
		that.ajaxCall(url,data,callback);
	},
	loadMore: function () {
		var that = this;
		var url = that.getAllUrl;
		var page = that.page;
		if(page>=that.maxPage){
			pullUp.style.display='none';
			return;
		}
		var data = {userid: that.userId,page:page+1,rows:this.rows};
		var callback = function () {
			if(++that.page>=that.maxPage){
				pullUp.style.display='none';
			}else{
				pullUp.style.display='block';
			}
			that.renderList(1);
		}
		that.ajaxCall(url,data,callback);
	},
	showMessges : function(messges) {
		$(".errorLabel").html(messges);
		$(".errorDiv").css("visibility", "visible");
		setTimeout('$(".errorDiv").css("visibility", "hidden")',3000);
	},
	clearJPush: function(){
		var jUserAgent = navigator.userAgent.toLowerCase();
		var jIsIphoneOs = jUserAgent.match(/iphone os/i) == "iphone os";
		var jIsAndroid = jUserAgent.match(/android/i) == "android";
		if(jIsIphoneOs){
			try{
				webView.callNative('jPushLogout'); // webView  ios的webView是大写的V
			}catch(e){
				alert('iOS: clear JPush exception');
			}
		}

		if(jIsAndroid){
			try{
				webview.setAliasAndTags('', ''); // webview  android的webview是小写的v
			} catch(e){
				alert('android: clear JPush exception');
			}
		}
	}
};
var Mine = {
	bindTabEvent: function(){
		$('.init-bar').on('click', function(event){
            if($(this).attr('id') === 'btn-bar-mine'){
                Common.redirectURL('mine.html','closeTitle','webview');
			}else if($(this).attr('id') === 'btn-bar-home'){
                Common.redirectURL('app.html','closeTitle','webview');
            }
            event.stopPropagation();
		});
	},
	bindTabDynamicClick: function(obj){
		Common.redirectURL($(obj).data('href'), $(obj).data('name'), $(obj).data('loadmode'), $(obj).data('category'));
	},
	initTab: function(){
		var _localStorage = window.localStorage;
		var _userId = _localStorage.getItem('_userId');
		$.ajax({
			url: module_exports.entry.index + '/rest/platform/getPlatformTabConfig',
			type: 'GET',
			data: {'userId': parseInt(_userId)},
			dataType: 'json',
			beforeSend: function () {
				//$('#ajax-loading').show();
	  		},
			success: function(data){
				if(!data.result){
					//$('#btn-loading').hide();
					//$('#ajax-loading').hide();
					return 0;
				}
				//$('#ajax-loading').hide();
				var jsonResult = data.objValue;
				
				// 动态tab
				var tabList = jsonResult.tabLinkList;
				var tabCount = 2; // 默认有[首页]和[我的]
				if(tabList != null && tabList.length > 0){
					var newTabCount = tabList.length;
					var tabWidth = (100/(tabCount + newTabCount)).toFixed(3); // 默认会四舍五入, 所以取3位，再截取即可(123.7849 -->123.785)           
					tabWidth = tabWidth.substring(0, tabWidth.lastIndexOf('.') + 3); // 截取后两位(123.78)
					
					for(var index in tabList){
						var src = tabList[index]['src'];
						var name = tabList[index]['name'];
						var loadmode = tabList[index]['loadmode'];
						var targeturl = tabList[index]['targeturl'];
						
						$('#btn-bar-home').after(
						'<li class="btn-bar" data-name="'+ name +'" data-href="'+ targeturl +'" data-loadmode="'+ loadmode +'" data-category="tabItem" onclick="Mine.bindTabDynamicClick(this);">'
						+	'<div class="bar-body">'
						+	'	<div class="bar-img">'
						+	'		<img alt="AD" src="'+ src +'" style="width: 18px; height: 18px; opacity: .6; filter: Alpha(opacity=.6);">'
						+	'	</div>'
						+	'	<div class="bar-title">'
						+ 	name
						+	'	</div>'
						+	'</div>'
						+	'</li>'
						);
					}
					$('.btn-bar').css({width: tabWidth + '%'});
				}
				
				// 底部工具栏
				Mine.bindTabEvent();

			},
			error: function(e){
				//$('#ajax-loading').hide();
				//$('#btn-loading').hide();
				//$('#btn-loading-error').html('网络异常, 点击重新加载 ').show();
				// 底部工具栏, initTab调用失败后，初始化的tab要依旧能使用
				//Mine.bindTabEvent();
				return 0;
			}
		});
	}
};
